﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Windows.Forms;

namespace PokerPDA
{
    public partial class Form1 : Form
    {
        int seat = 0;
        int board = 0;
        int preset = 0;
        string username = "";
        bool[] seatTaken = new bool[9] {true, false, false, false, false, false, false, false, false };

        public enum Rank
        { TWO = 0, THREE, FOUR, FIVE, SIX, SEVEN, EIGHT, NINE, TEN, JACK, QUEEN, KING, ACE }

        public enum Suit
        { CLUBS = 0, DIAMONDS, HEARTS, SPADES }

        public enum HandType
        { STRAIGHTFLUSH = 8, FOUROFAKIND = 7, FULLHOUSE = 6, FLUSH = 5, STRAIGHT = 4, THREEOFAKIND = 3, TWOPAIR = 2, PAIR = 1, HIGHCARD = 0 }
        
        public enum TableState
        { INIT = 0, PREFLOP_DEAL, PREFLOP_BET, FLOP_DEAL, FLOP_BET, TURN_DEAL, TURN_BET, RIVER_DEAL, RIVER_BET, FINAL, END }

        Poker_client obj;
        Poker_client chat;

        TableState t = TableState.INIT;

        public Form1()
        {
            InitializeComponent();
            obj = new Poker_client(true,this);
            obj.Connect_to_Sever();
            chat = new Poker_client(false, this);
            chat.Connect_to_Sever();
        }

        public void show(string msg)
        {
            label1.Text = label2.Text;
            label2.Text = label3.Text;
            label3.Text = label4.Text;
            label4.Text = label5.Text;
            label5.Text = label6.Text;
            label6.Text = label7.Text;
            label7.Text = label8.Text;
            label8.Text = label9.Text;
            label9.Text = label10.Text;
            label10.Text = label11.Text;
            label11.Text = label12.Text;
            label12.Text = label13.Text;
            label13.Text = msg;
            if (tabControl1.SelectedIndex == 0)
                label14.Visible = true;
        }

        public void show_label(string msg)
        {
            StateLabel.Text = msg;
        }

        public void show_table(int state)
        {
            t = (TableState)state;
            StateLabel.Text = t.ToString();
            //richTextBox1.Text += t.ToString();
            //richTextBox1.Text += Environment.NewLine;
            if (t == TableState.INIT)
            {
                board_0.Image = null;
                board_1.Image = null;
                board_2.Image = null;
                board_3.Image = null;
                board_4.Image = null;
                hole_0.Image = null;
                hole_1.Image = null;

                player1_0.Image = null;
                player1_1.Image = null;
                player2_0.Image = null;
                player2_1.Image = null;
                player3_0.Image = null;
                player3_1.Image = null;
                player4_0.Image = null;
                player4_1.Image = null;
                player5_0.Image = null;
                player5_1.Image = null;
                player6_0.Image = null;
                player6_1.Image = null;
                player7_0.Image = null;
                player7_1.Image = null;
                player8_0.Image = null;
                player8_1.Image = null;

                JackpotLabel.Text = "";
                board = 0;
            }

            if (t == TableState.FLOP_DEAL || t == TableState.TURN_DEAL || t == TableState.RIVER_DEAL || t == TableState.FINAL || t == TableState.END)
            {
                player0.Text = player0.Text.Split("/".ToCharArray()).Last();
                player1.Text = player1.Text.Split("/".ToCharArray()).Last();
                player2.Text = player2.Text.Split("/".ToCharArray()).Last();
                player3.Text = player3.Text.Split("/".ToCharArray()).Last();
                player4.Text = player4.Text.Split("/".ToCharArray()).Last();
                player5.Text = player5.Text.Split("/".ToCharArray()).Last();
                player6.Text = player6.Text.Split("/".ToCharArray()).Last();
                player7.Text = player7.Text.Split("/".ToCharArray()).Last();
                player8.Text = player8.Text.Split("/".ToCharArray()).Last();
                preset = 0;
            }

            if (t == TableState.END && seat == 0)
                button11.Visible = true;
        }

        public void show_seat(int empty_seat)
        {
            //richTextBox1.Text += empty_seat.ToString();
            //richTextBox1.Text += Environment.NewLine;
            switch (empty_seat)
            {
                case 0:
                    button11.Visible = true;
                    break;
                case 1:
                    button11.Visible = false;
                    showButtons();
                    button1.Enabled = true;
                    break;
                case 2:
                    button11.Visible = false;
                    showButtons();
                    button2.Enabled = true;
                    break;
                case 3:
                    button11.Visible = false;
                    showButtons();
                    button3.Enabled = true;
                    break;
                case 4:
                    button11.Visible = false;
                    showButtons();
                    button4.Enabled = true;
                    break;
                case 5:
                    button11.Visible = false;
                    showButtons();
                    button5.Enabled = true;
                    break;
                case 6:
                    button11.Visible = false;
                    showButtons();
                    button6.Enabled = true;
                    break;
                case 7:
                    button11.Visible = false;
                    showButtons();
                    button7.Enabled = true;
                    break;
                case 8:
                    button11.Visible = false;
                    showButtons();
                    button8.Enabled = true;
                    break;
            }

        }

        void showButtons()
        {
            button1.Visible = true;
            button2.Visible = true;
            button3.Visible = true;
            button4.Visible = true;
            button5.Visible = true;
            button6.Visible = true;
            button7.Visible = true;
            button8.Visible = true;
        }

        public void show_board_card(int[] cards)
        {
            //richTextBox1.Text += "board_card";
            //richTextBox1.Text += Environment.NewLine;

            Suit s1 = (Suit)cards[0];
            Rank r1 = (Rank)cards[1];

            switch (board)
            {
                case 0:
                    board_0.Image = imageList1.Images[cards[1] * 4 + cards[0]];
                    break;
                case 1:
                    board_1.Image = imageList1.Images[cards[1] * 4 + cards[0]];
                    break;
                case 2:
                    board_2.Image = imageList1.Images[cards[1] * 4 + cards[0]];
                    break;
                case 3:
                    board_3.Image = imageList1.Images[cards[1] * 4 + cards[0]];
                    break;
                case 4:
                    board_4.Image = imageList1.Images[cards[1] * 4 + cards[0]];
                    break;
            }

            board++;

            //richTextBox1.Text += r1.ToString() + " of " + s1.ToString();
            //richTextBox1.Text += Environment.NewLine;

        }

        public void show_hold_card(int[] cards)
        {
            //richTextBox1.Text += "hold_card";
            //richTextBox1.Text += Environment.NewLine;

            Suit s1 = (Suit)cards[0];
            Rank r1 = (Rank)cards[1];
            Suit s2 = (Suit)cards[2];
            Rank r2 = (Rank)cards[3];

            hole_0.Image = imageList1.Images[cards[1] * 4 + cards[0]];
            hole_1.Image = imageList1.Images[cards[3] * 4 + cards[2]];

            //richTextBox1.Text += r1.ToString() + " of " + s1.ToString();
            //richTextBox1.Text += Environment.NewLine;
            //richTextBox1.Text += r2.ToString() + " of " + s2.ToString();
            //richTextBox1.Text += Environment.NewLine;
            if (seatTaken[1] == true)
            {
                player1_0.Image = imageList1.Images[52];
                player1_1.Image = imageList1.Images[52];
            }
            if (seatTaken[2] == true)
            {
                player2_0.Image = imageList1.Images[52];
                player2_1.Image = imageList1.Images[52];
            }
            if (seatTaken[3] == true)
            {
                player3_0.Image = imageList1.Images[52];
                player3_1.Image = imageList1.Images[52];
            }
            if (seatTaken[4] == true)
            {
                player4_0.Image = imageList1.Images[52];
                player4_1.Image = imageList1.Images[52];
            }
            if (seatTaken[5] == true)
            {
                player5_0.Image = imageList1.Images[52];
                player5_1.Image = imageList1.Images[52];
            }
            if (seatTaken[6] == true)
            {
                player6_0.Image = imageList1.Images[52];
                player6_1.Image = imageList1.Images[52];
            }
            if (seatTaken[7] == true)
            {
                player7_0.Image = imageList1.Images[52];
                player7_1.Image = imageList1.Images[52];
            }
            if (seatTaken[8] == true)
            {
                player8_0.Image = imageList1.Images[52];
                player8_1.Image = imageList1.Images[52];
            }

        }

        public void show_winner(int winner)
        {
            switch ((winner + 9 - seat) % 9)
            {
                case 0:
                    player0.Text = "winner";
                    break;
                case 1:
                    player1.Text = "winner";
                    break;
                case 2:
                    player2.Text = "winner";
                    break;
                case 3:
                    player3.Text = "winner";
                    break;
                case 4:
                    player4.Text = "winner";
                    break;
                case 5:
                    player5.Text = "winner";
                    break;
                case 6:
                    player6.Text = "winner";
                    break;
                case 7:
                    player7.Text = "winner";
                    break;
                case 8:
                    player8.Text = "winner";
                    break;
            }
        }

        public void show_winner_card(int[] info)
        {
            //richTextBox1.Text += "player " + info[0].ToString() + " wins";
            //richTextBox1.Text += Environment.NewLine;

            Suit s1 = (Suit)info[1];
            Rank r1 = (Rank)info[2];
            Suit s2 = (Suit)info[3];
            Rank r2 = (Rank)info[4];

            switch ((info[0] + 9 - seat) % 9)
            {
                case 0:
                    player0.Text = "winner";
                    break;
                case 1:
                    player1.Text = "winner";
                    player1_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player1_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
                case 2:
                    player2.Text = "winner";
                    player2_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player2_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
                case 3:
                    player3.Text = "winner";
                    player3_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player3_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
                case 4:
                    player4.Text = "winner";
                    player4_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player4_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
                case 5:
                    player5.Text = "winner";
                    player5_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player5_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
                case 6:
                    player6.Text = "winner";
                    player6_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player6_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
                case 7:
                    player7.Text = "winner";
                    player7_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player7_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
                case 8:
                    player8.Text = "winner";
                    player8_0.Image = imageList1.Images[info[2] * 4 + info[1]];
                    player8_1.Image = imageList1.Images[info[4] * 4 + info[3]];
                    break;
            }

            //richTextBox1.Text += r1.ToString() + " of " + s1.ToString();
            //richTextBox1.Text += Environment.NewLine;
            //richTextBox1.Text += r2.ToString() + " of " + s2.ToString();
            //richTextBox1.Text += Environment.NewLine;

        }

        public void show_balance(int[] balance)
        {
            //richTextBox1.Text += "player " + balance[0].ToString() + " with money: " + balance[1].ToString();
            //richTextBox1.Text += Environment.NewLine;

            if (t != TableState.FINAL && t!= TableState.END)
                switch ((balance[0] + 9 - seat) % 9)
                {
                    case 0:
                        player0.Text = balance[1].ToString();
                        break;
                    case 1:
                        player1.Text = balance[1].ToString();
                        break;
                    case 2:
                        player2.Text = balance[1].ToString();
                        break;
                    case 3:
                        player3.Text = balance[1].ToString();
                        break;
                    case 4:
                        player4.Text = balance[1].ToString();
                        break;
                    case 5:
                        player5.Text = balance[1].ToString();
                        break;
                    case 6:
                        player6.Text = balance[1].ToString();
                        break;
                    case 7:
                        player7.Text = balance[1].ToString();
                        break;
                    case 8:
                        player8.Text = balance[1].ToString();
                        break;
                }
            seatTaken[(balance[0] + 9 - seat) % 9] = true;
        }

        public void show_bet_info(int[] info)
        {
            //richTextBox1.Text += "player " + info[0].ToString() + " bets " + info[1].ToString();
            //richTextBox1.Text += Environment.NewLine;
            if (t != TableState.FINAL && t != TableState.END)
                switch ((info[0] + 9 - seat) % 9)
                {
                    case 0:
                        player0.Text = info[1] + "/" + info[2];
                        break;
                    case 1:
                        player1.Text = info[1] + "/" + info[2];
                        break;
                    case 2:
                        player2.Text = info[1] + "/" + info[2];
                        break;
                    case 3:
                        player3.Text = info[1] + "/" + info[2];
                        break;
                    case 4:
                        player4.Text = info[1] + "/" + info[2];
                        break;
                    case 5:
                        player5.Text = info[1] + "/" + info[2];
                        break;
                    case 6:
                        player6.Text = info[1] + "/" + info[2];
                        break;
                    case 7:
                        player7.Text = info[1] + "/" + info[2];
                        break;
                    case 8:
                        player8.Text = info[1] + "/" + info[2];
                        break;
                }
            preset = info[1];
        }

        public void show_jackpot(int jackpot)
        {
            //richTextBox1.Text += "jackpot: " + jackpot.ToString();
            JackpotLabel.Text = jackpot.ToString();
        }

        public void get_bet(string v)
        {
            //button5.Enabled = true;
            button9.Visible = true;
            button9.Enabled = true;
            textBox2.Visible = true;
            textBox2.Text = preset.ToString();
        }

        private void button_send_Click(object sender, EventArgs e)
        {
            chat.SendMessage(textBox1.Text);
            show(username + " : " + textBox1.Text);
            textBox1.Text = "";
        }

        private void button0_Click(object sender, EventArgs e)
        {
            seat = 0;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            seat = 1;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            seat = 2;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            seat = 3;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            seat = 4;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            seat = 5;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            seat = 6;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            seat = 7;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            seat = 8;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
            obj.SendInt(seat);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            obj.SendInt(Int32.Parse(textBox2.Text));
            button9.Enabled = false;
            button9.Visible = false;
            textBox2.Visible = false;
        }

        private void button10_Click(object sender, EventArgs e)
        {
            obj.SendMessage(textBox2.Text);
            chat.SendMessage(textBox2.Text);
            username = textBox2.Text;
            button10.Visible = false;
            textBox2.Visible = false;
            button11.Visible = true;
            pictureBox1.Visible = false;
        }

        private void button11_Click(object sender, EventArgs e)
        {
            obj.SendByte();
            button11.Visible = false;
            button0.Visible = false;
            button1.Visible = false;
            button2.Visible = false;
            button3.Visible = false;
            button4.Visible = false;
            button5.Visible = false;
            button6.Visible = false;
            button7.Visible = false;
            button8.Visible = false;
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (tabControl1.SelectedIndex == 1)
                label14.Visible = false;
        }

    }

    class Poker_client
    {
        IAsyncResult m_result;
        public AsyncCallback m_pfnCallBack;
        public Socket m_clientSocket;
        public String msg;
        ///true:poker,false:dialogue
        public bool type;

        public delegate void Show_on_screen(string m);
        public delegate void int_delegate(int m);
        public delegate void ints_del(int[] m);

        Form1 _refform;

        public class SocketPacket
        {
            public System.Net.Sockets.Socket thisSocket;
            public byte[] dataBuffer = new byte[1024];

        }

        public Poker_client(bool type_in, Form1 f)
        {
            type = type_in;
            msg = GetIP();
            _refform = f;

        }
        public string GetIP()
        {
            string strHostName = Dns.GetHostName();

            // Find host by name
            IPHostEntry iphostentry = Dns.GetHostByName(strHostName);

            // Grab the first IP addresses
            string IPStr = "";
            foreach (IPAddress ipaddress in iphostentry.AddressList)
            {
                IPStr = ipaddress.ToString();
                return IPStr;
            }
            return IPStr;
        }

        public void Connect_to_Sever()
        {
            // Create the socket instance
            m_clientSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            // Cet the remote IP address
            IPAddress ip = IPAddress.Parse("140.112.18.208");
            //int iPortNo = System.Convert.ToInt16 ( "140.112.18.208");
            // Create the end point 
            IPEndPoint ipEnd;
            if (type)
            {
                ipEnd = new IPEndPoint(ip, 5208);
            }
            else
            {
                ipEnd = new IPEndPoint(ip, 32377);
            }


            // Connect to the remote host
            m_clientSocket.Connect(ipEnd);

            _refform.Invoke(new Show_on_screen(_refform.show_label), m_clientSocket.LocalEndPoint.ToString());

            //SendMessage(nickname);
            if (m_clientSocket.Connected)
            {
                //Wait for data asynchronously 

                WaitForData();
            }

        }

        public void WaitForData()
        {
            try
            {
                if (m_pfnCallBack == null)
                {
                    m_pfnCallBack = new AsyncCallback(OnDataReceived);
                }
                SocketPacket theSocPkt = new SocketPacket();
                theSocPkt.thisSocket = m_clientSocket;
                // Start listening to the data asynchronously
                m_result = m_clientSocket.BeginReceive(theSocPkt.dataBuffer,
                                                        0, theSocPkt.dataBuffer.Length,
                                                        SocketFlags.None,
                                                        m_pfnCallBack,
                                                        theSocPkt);
            }
            catch (SocketException se)
            {
                MessageBox.Show(se.Message);
            }

        }

        public void OnDataReceived(IAsyncResult asyn)
        {
            try
            {
                SocketPacket theSockId = (SocketPacket)asyn.AsyncState;
                int iRx = theSockId.thisSocket.EndReceive(asyn);
                /*char[] chars = new char[iRx + 1];
                System.Text.Decoder d = System.Text.Encoding.Unicode.GetDecoder();
                int charLen = d.GetChars(theSockId.dataBuffer, 0, iRx, chars, 0);
                System.String szData = new System.String(chars);
                msg = szData;*/

                if (type)
                {
                    int header;
                    bool ackRequired = true;
                    header = BitConverter.ToInt32(theSockId.dataBuffer, 0);
                    switch (header)
                    {
                        case 10://///choose seat
                            int seat_num;
                            seat_num = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            int empty_seat;
                            for (int i = 0; i < seat_num; i++)
                            {
                                empty_seat = BitConverter.ToInt32(theSockId.dataBuffer, 8 + 4 * i);
                                _refform.Invoke(new int_delegate(_refform.show_seat), empty_seat);
                            }
                            ackRequired = false;
                            break;
                        case 11://///show_table
                            int state;
                            state = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            _refform.Invoke(new int_delegate(_refform.show_table), state);
                            break;
                        case 12://///show_balance
                            int player_num;
                            player_num = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            int[] balance = new int[2];
                            for (int i = 0; i < player_num; i++)
                            {
                                balance[0] = BitConverter.ToInt32(theSockId.dataBuffer, 8 + 8 * i);
                                balance[1] = BitConverter.ToInt32(theSockId.dataBuffer, 12 + 8 * i);
                                _refform.Invoke(new ints_del(_refform.show_balance), balance);
                            }
                            break;
                        case 13://///update
                            int player;
                            player = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            int[] info = new int[2];
                            for (int i = 0; i < player; i++)
                            {
                                info[0] = BitConverter.ToInt32(theSockId.dataBuffer, 8 + 8 * i);
                                info[1] = BitConverter.ToInt32(theSockId.dataBuffer, 12 + 8 * i);
                                _refform.Invoke(new ints_del(_refform.show_balance), info);
                            }
                            int card_num;
                            card_num = BitConverter.ToInt32(theSockId.dataBuffer, 8 + 8 * player);
                            int[] card_u = new int[2];
                            for (int i = 0; i < card_num; i++)
                            {
                                card_u[0] = BitConverter.ToInt32(theSockId.dataBuffer, 12 + 8 * player + 8 * i);
                                card_u[1] = BitConverter.ToInt32(theSockId.dataBuffer, 16 + 8 * player + 8 * i);
                                _refform.Invoke(new ints_del(_refform.show_board_card), card_u);
                            }

                            break;
                        case 21://///bet
                            _refform.Invoke(new Show_on_screen(_refform.get_bet), "");
                            ackRequired = false;
                            break;
                        case 22:///3 cards
                            int[] cards_3 = new int[2];
                            for (int i = 0; i < 3; i++)
                            {
                                cards_3[0] = BitConverter.ToInt32(theSockId.dataBuffer, 4 + 8 * i);
                                cards_3[1] = BitConverter.ToInt32(theSockId.dataBuffer, 8 + 8 * i);
                                _refform.Invoke(new ints_del(_refform.show_board_card), cards_3);
                            }
                            break;
                        case 23:///2 card
                            int[] cards_2 = new int[4];
                            cards_2[0] = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            cards_2[1] = BitConverter.ToInt32(theSockId.dataBuffer, 8);
                            cards_2[2] = BitConverter.ToInt32(theSockId.dataBuffer, 12);
                            cards_2[3] = BitConverter.ToInt32(theSockId.dataBuffer, 16);
                            _refform.Invoke(new ints_del(_refform.show_hold_card), cards_2);
                            break;
                        case 24:///1 card
                            int[] card = new int[2];
                            card[0] = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            card[1] = BitConverter.ToInt32(theSockId.dataBuffer, 8);
                            _refform.Invoke(new ints_del(_refform.show_board_card), card);
                            break;
                        case 25:///endround
                            int winner_num;
                            winner_num = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            int[] winner_info = new int[6];
                            winner_info[5] = BitConverter.ToInt32(theSockId.dataBuffer, 8);
                            for (int i = 0; i < winner_num; i++)
                            {
                                winner_info[0] = BitConverter.ToInt32(theSockId.dataBuffer, 12 + 20 * i);
                                winner_info[1] = BitConverter.ToInt32(theSockId.dataBuffer, 16 + 20 * i);
                                winner_info[2] = BitConverter.ToInt32(theSockId.dataBuffer, 20 + 20 * i);
                                winner_info[3] = BitConverter.ToInt32(theSockId.dataBuffer, 24 + 20 * i);
                                winner_info[4] = BitConverter.ToInt32(theSockId.dataBuffer, 28 + 20 * i);


                                _refform.Invoke(new ints_del(_refform.show_winner_card), winner_info);
                            }
                            break;
                        case 26:///tell bet
                            int[] bet_info = new int[3];

                            bet_info[0] = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            bet_info[1] = BitConverter.ToInt32(theSockId.dataBuffer, 8);
                            bet_info[2] = BitConverter.ToInt32(theSockId.dataBuffer, 12);
                            _refform.Invoke(new ints_del(_refform.show_bet_info), bet_info);
                            break;

                        case 27:///tell jackpot
                            int jackpot;

                            jackpot = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            _refform.Invoke(new int_delegate(_refform.show_jackpot), jackpot);
                            break;
                        case 28:///just show winner
                            int winner;

                            winner = BitConverter.ToInt32(theSockId.dataBuffer, 4);
                            _refform.Invoke(new int_delegate(_refform.show_winner), winner);
                            break;
                        default:
                            char[] chars = new char[iRx + 1];
                            System.Text.Decoder d = System.Text.Encoding.Unicode.GetDecoder();
                            int charLen = d.GetChars(theSockId.dataBuffer, 0, iRx, chars, 0);
                            msg = new System.String(chars);
                            _refform.Invoke(new Show_on_screen(_refform.show), msg);
                            break;

                    }
                    if (ackRequired)
                        SendInt(1);
                }
                else
                {
                    char[] chars = new char[iRx + 1];
                    System.Text.Decoder d = System.Text.Encoding.Unicode.GetDecoder();
                    int charLen = d.GetChars(theSockId.dataBuffer, 0, iRx, chars, 0);
                    msg = new System.String(chars);
                    _refform.Invoke(new Show_on_screen(_refform.show), msg);
                }



                Array.Clear(theSockId.dataBuffer, 0, theSockId.dataBuffer.Length);
                WaitForData();
            }
            catch (SocketException se)
            {
                MessageBox.Show(se.Message);
            }
        }

        public void SendMessage(String message)
        {
            try
            {
                byte[] byData;

                byData = System.Text.Encoding.Unicode.GetBytes(message);

                if (m_clientSocket != null)
                {
                    m_clientSocket.Send(byData);
                }

            }
            catch (SocketException se)
            {
                MessageBox.Show(se.Message);
            }
        }

        public void SendByte()
        {
            try
            {
                byte[] byData = new byte[1];

                byData[0] = byte.Parse("1");

                if (m_clientSocket != null)
                {
                    m_clientSocket.Send(byData);
                }

            }
            catch (SocketException se)
            {
                MessageBox.Show(se.Message);
            }
        }

        public void SendInt(int i)
        {
            try
            {
                byte[] byData;

                byData = BitConverter.GetBytes(i);

                if (m_clientSocket != null)
                {
                    m_clientSocket.Send(byData);
                }

            }
            catch (SocketException se)
            {
                MessageBox.Show(se.Message);
            }
        }

        public void Disconnect()
        {
            if (m_clientSocket != null)
            {
                m_clientSocket.Close();
                m_clientSocket = null;
            }
        }


    }
}