﻿using System;
using System.Collections.Generic;

namespace PokerClass
{
    public class Card
    {
        public static int DECKSIZE = 52;
        
        public enum Rank
        {TWO=0, THREE, FOUR, FIVE, SIX, SEVEN, EIGHT, NINE, TEN, JACK, QUEEN, KING, ACE}

        public enum Suit
        {CLUBS=0, DIAMONDS, HEARTS, SPADES}

        public static Rank[] Ranks = { Card.Rank.TWO, Card.Rank.THREE, Card.Rank.FOUR, Card.Rank.FIVE, Card.Rank.SIX, Card.Rank.SEVEN, Card.Rank.EIGHT, Card.Rank.NINE, Card.Rank.TEN, Card.Rank.JACK, Card.Rank.QUEEN, Card.Rank.KING, Card.Rank.ACE };
        public static Suit[] Suits = { Card.Suit.CLUBS, Card.Suit.DIAMONDS, Card.Suit.HEARTS, Card.Suit.SPADES };

        public Rank rank;
        public Suit suit;

        public Card(Rank rank, Suit suit)
        {
            this.rank = rank;
            this.suit = suit;
        }

        public string CardString()
        {
            return rank + " of " + suit;
        }
        
        public int SuitInt()
        {
           return (int)suit ;          
        }
        
        public int RankInt()
        {
           return (int)rank ;
        }              

        public static List<Card> getAllCards()
        {
            List<Card> deck = new List<Card>();
            foreach(Rank currentRank in Ranks)
                foreach(Suit currentSuit in Suits)
                    deck.Add(new Card(currentRank,currentSuit));
            return deck;
        }

        public static List<Card> getShuffledCards()
        {
            List<Card> deck = new List<Card>();
            List<Card> shuffled = new List<Card>();
            foreach (Rank currentRank in Ranks)
                foreach (Suit currentSuit in Suits)
                    deck.Add(new Card(currentRank, currentSuit));

            Random r = new Random();
            int randomIndex = 0;
            while (deck.Count > 0)
            {
                randomIndex = r.Next(0, deck.Count); //Choose a random object in the list
                shuffled.Add(deck[randomIndex]); //add it to the new, random list<
                deck.RemoveAt(randomIndex); //remove to avoid duplicates
            }

            return shuffled;
        }
    }
}