﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using MyTcp;

namespace Poker_Server
{
   class ChatAgent<T> : Agent<T> where T : IShowable
   {
      public ChatAgent() { }
      public ChatAgent(T w) : base(w) { }     
      public enum ChatStatus
      {
         Login = 0 ,
         Ready = 1 ,
      }
      public ChatStatus _status = ChatStatus.Login ;
      public string _nickname ;

      // Change this in order to have different function
      public override void ProcessMain(int iRx)
      {         
         // Clear the response buffer first
         if (_responseBuffer != null)
            Array.Clear(_responseBuffer, 0, _responseBuffer.Length);

         // Process the incoming data _dataBuffer
         // For testing
         if( _status == ChatStatus.Login ) {
            string name = System.Text.Encoding.Unicode.GetString(_dataBuffer, 0, iRx) ;
            _nickname = name ;
            ShowMessage( _nickname ) ;
            _status = ChatStatus.Ready ;
         }
         else {
            string data = System.Text.Encoding.Unicode.GetString(_dataBuffer, 0, iRx);
            string sentence =  _nickname + " : " + data ;
            ShowMessage( sentence );
            foreach (ChatAgent<T> a in _listRef)
               if (a.AgentID != this.AgentID)
                  a.Send(System.Text.Encoding.Unicode.GetBytes(sentence));
         }         

         // After the incoming data is processed, clear _dataBuffer
         Array.Clear(_dataBuffer, 0, _dataBuffer.Length);
      }

      public override void HandleDisconnection(SocketException se)
      {

      }

   }
}