﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Net;
using System.Net.Sockets;
using MyTcp;

namespace Poker_Server
{
   /// <summary>
   /// Window1.xaml 的互動邏輯
   /// </summary>
   public partial class Window1 : Window , IShowable
   {
      private int pokerPort = 5208;
      private int chatPort = 32377;
      private IPAddress localAddr = IPAddress.Parse("140.112.18.208");
      public AsyncCallback pfnWorkerCallBack;
      
      public Window1()
      {
         InitializeComponent();
         MyTcpServer<Window1, PokerAgent<Window1> > pokerServer 
            = new MyTcpServer<Window1, PokerAgent<Window1> >(pokerPort, localAddr, this) ;
         pokerServer.StartServer() ;
         MyTcpServer<Window1, ChatAgent<Window1> > chatServer 
            = new MyTcpServer<Window1,ChatAgent<Window1> >(chatPort, localAddr, this) ;
         chatServer.StartServer() ;
      }

      private void buttonStart_Click(object sender, RoutedEventArgs e)
      {

      }

      public delegate void StringDelegate(string s);
      public void ShowMessage(string s) 
      {        
         this.Dispatcher.Invoke(new StringDelegate(Show), s) ;
         //_windowRef.Dispatcher.Invoke(DispatcherPriority.Normal, new Window1.StringDelegate(_windowRef.ShowMessage), s);
      }
      
      public void Show(string s)
      {         
         richTextBox1.AppendText(s) ;
      }     

      private void Window_Loaded(object sender, RoutedEventArgs e)
      {

      }
      
   }
}
